#ifndef YM2203_H_INCLUDED
#define YM2203_H_INCLUDED

#include "../typedef.h"
#include "../ini.h"
#include "psgbase.h"
#include "fmgen/opna.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cYM2203 : public cPSG, public virtual IDoko {
protected:
	FM::OPN	opn;
	
	BYTE RegTimerA1, RegTimerA2;
	BYTE RegTimerB;
	BYTE RegTimerCtr;
	
	void _WriteReg( BYTE, BYTE );		// WX^݃Tu
	void WriteReg( BYTE, BYTE );		// WX^
	BYTE ReadReg();						// WX^Ǎ
	BYTE ReadStatus();					// Xe[^XWX^Ǎ
	
	void SetClock( int, int );			// NbNݒ
	void SetVolumeTable( int );			// ʐݒ({[e[uݒ)
	
	bool Init( int, int );				// 
	void Reset();						// Zbg
	
	virtual void SetTimerA( int ){}		// TimerAݒ
	virtual void SetTimerB( int ){}		// TimerBݒ
	
	bool TimerIntr();					// ^C}ݔ
	
public:
	cYM2203();							// RXgN^
	virtual ~cYM2203();					// fXgN^
	
	int Update1Sample();				// Xg[1SampleXV
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


#endif	// YM2203_H_INCLUDED
